/*  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  Data Differential YATL (i.e. libtest)  library
 *
 *  Copyright (C) 2012 Data Differential, http://datadifferential.com/
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are
 *  met:
 *
 *      * Redistributions of source code must retain the above copyright
 *  notice, this list of conditions and the following disclaimer.
 *
 *      * Redistributions in binary form must reproduce the above
 *  copyright notice, this list of conditions and the following disclaimer
 *  in the documentation and/or other materials provided with the
 *  distribution.
 *
 *      * The names of its contributors may not be used to endorse or
 *  promote products derived from this software without specific prior
 *  written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#pragma once

#if defined(HAVE_LIBMEMCACHED) && HAVE_LIBMEMCACHED
inline bool operator== (const memcached_st& memc, const memcached_return_t rc)
{
  if (memcached_last_error(const_cast<memcached_st *>(&memc)) == rc)
  {
    return true;
  }

  return false;
}

inline bool operator!= (const memcached_st& memc, memcached_return_t rc)
{
  if (memcached_last_error(const_cast<memcached_st *>(&memc)) != rc)
  {
    return true;
  }

  return false;
}

inline bool operator== (memcached_st* const memc, memcached_return_t rc)
{
  if (memcached_last_error(memc) == rc)
  {
    return true;
  }

  return false;
}

inline bool operator!= (memcached_st* const memc, memcached_return_t rc)
{
  if (memcached_last_error(memc) != rc)
  {
    return true;
  }

  return false;
}

inline bool operator!= (memcached_return_t rc, const memcached_st& memc)
{
  if (memcached_last_error(const_cast<memcached_st *>(&memc)) != rc)
  {
    return true;
  }

  return false;
}

inline bool operator!= (memcached_return_t rc, memcached_st* const memc)
{
  if (memcached_last_error(memc) != rc)
  {
    return true;
  }

  return false;
}
#endif

